package com.dsic.gj_erp.service.jcsj.impl;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.request.EmSbjbbBean;
import com.dsic.gj_erp.dao.jcsj.EmSbjbbRepository;
import com.dsic.gj_erp.mapper.jcsj.EmSbjbbMapper;
import com.dsic.gj_erp.service.jcsj.EmSbjbbService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class EmSbjbbServiceImpl extends ServiceImpl<EmSbjbbMapper, EmSbjbb> implements EmSbjbbService {
    @Resource
    EmSbjbbMapper emSbjbbMapper;
    @Resource
    EmSbjbbRepository emSbjbbRepository;

    @Override
    public List<EmSbjbb> getList(EmSbjbbBean emSbjbbBean) {
        QueryWrapper<EmSbjbb> queryWrapper=new QueryWrapper<>();
        String sbbh=emSbjbbBean.getSbbh();
        String szcs=emSbjbbBean.getSzcs();
        String gysbm=emSbjbbBean.getGysbm();
        if(StringUtils.isNotEmpty(sbbh)){
            queryWrapper.eq("SBBH",sbbh);
        }
        if(StringUtils.isNotEmpty(szcs)){
            queryWrapper.eq("SZCS",szcs);
        }
        if(StringUtils.isNotEmpty(gysbm)){
            queryWrapper.eq("GYSBM",gysbm);
        }
        queryWrapper.orderByDesc("GRRQ");
        List<EmSbjbb> emSbjbbs=emSbjbbMapper.selectList(queryWrapper);
        return emSbjbbs;
    }

    @Override
    public void save(List<EmSbjbb> emSbjbbs, HttpServletRequest request) {
        String yhms=(String) request.getAttribute("yhms");
        emSbjbbs.forEach(emSbjbb -> {
            if (StringUtils.isNotEmpty(emSbjbb.getSbbh())){
                Date date = new Date();//获取当前时间
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");//定义日期格式
                String dateString = dateFormat.format(date);
                emSbjbb.setZdsj(dateString);
                emSbjbb.setZdry(yhms);
            }
        });
        saveBatch(emSbjbbs);
    }

    @Override
    public void update(List<EmSbjbb> emSbjbbs) {
       // update(emSbjbbs);
        updateBatchById(emSbjbbs);
    }

    @Override
    public void delete(List<EmSbjbb> emSbjbbs) {
        List<String> idList=emSbjbbs.stream().map(EmSbjbb::getSbbh).collect(Collectors.toList());
        emSbjbbMapper.deleteBatchIds(idList);
    }

    @Override
    public List<Map> getGYS() {
        List<Map> emSbjbbs=emSbjbbRepository.gys();
        return emSbjbbs;
    }

    @Override
    public List<Map> getSBLX() {
        List<Map> emSbjbbs=emSbjbbRepository.sblx();
        return emSbjbbs;
    }
}
