package com.dsic.gj_erp.service.jhgk.impl;


import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmJtsyjh;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.dao.jhgk.DmJtsyjhRepository;
import com.dsic.gj_erp.mapper.jhgk.DmJtsyjhMapper;
import com.dsic.gj_erp.service.jhgk.DmJtsyjhService;
import com.dsic.gj_erp.util.ExcelUtil;
import com.google.common.collect.Lists;
import org.apache.commons.lang3.StringUtils;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class DmJtsyjhServiceImpl extends ServiceImpl<DmJtsyjhMapper, DmJtsyjh> implements DmJtsyjhService {
    @Resource
    DmJtsyjhMapper dmJtsyjhMapper;
    @Resource
    ModelMapper modelMapper;


    @Override
    public List<DmJtsyjh> getList(JSONObject json) {
        QueryWrapper<DmJtsyjh> queryWrapper=new QueryWrapper<>();
        if(StringUtils.isNotEmpty(json.getString("dcCh"))){
            queryWrapper.eq("dc_ch",json.getString("dcCh"));
        }
        if(StringUtils.isNotEmpty(json.getString("Zt"))){
            queryWrapper.eq("zt",json.getString("Zt"));
        }
        List<DmJtsyjh> dmTzjhs=dmJtsyjhMapper.selectList(queryWrapper);
        return dmTzjhs;
    }

    @Override
    public List<DmJtsyjh> upload(MultipartFile file) throws IOException {
        List<Map<String,Object>> list= ExcelUtil.readJTSYJH(file);
        List<DmJtsyjh> dmJtsyjhs=new ArrayList<>();
        list.forEach(stringObjectMap -> {
            String[] fds=stringObjectMap.get("dcFd").toString().split("/");
            for (String fd:fds) {
                DmJtsyjh dmZrcjh = modelMapper.map(stringObjectMap, DmJtsyjh.class);
                dmZrcjh.setDcFd(fd);
                dmJtsyjhs.add(dmZrcjh);
            }
        });
        return dmJtsyjhs;
    }

    @Override
    public void save(List<DmJtsyjh> dmJtsyjhs) {
        saveBatch(dmJtsyjhs);
        List<List<DmJtsyjh>> lists = Lists.partition(dmJtsyjhs, 300);
        for (List<DmJtsyjh> list:lists) {
            dmJtsyjhMapper.updateCzplpNEW(list);
        }
    }

    @Override
    public void tj(List<DmJtsyjh> dmJtsyjhs) {
        dmJtsyjhs.forEach(dmXbjh -> {
            dmXbjh.setZt("1");
        });
        updateBatchById(dmJtsyjhs);
    }


}
