package com.dsic.gj_erp.service.jhgk.impl;


import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmXbjh;
import com.dsic.gj_erp.mapper.jhgk.DmXbjhMapper;
import com.dsic.gj_erp.service.jhgk.DmXbjhService;
import com.dsic.gj_erp.util.ExcelUtil;
import org.apache.commons.lang3.StringUtils;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class DmXbjhServiceImpl extends ServiceImpl<DmXbjhMapper, DmXbjh> implements DmXbjhService {
    @Resource
    DmXbjhMapper dmXbjhMapper;
    @Resource
    ModelMapper modelMapper;

    @Override
    public List<DmXbjh> getList(JSONObject json) {
        QueryWrapper<DmXbjh> queryWrapper=new QueryWrapper<>();
        if(StringUtils.isNotEmpty(json.getString("dcCh"))){
            queryWrapper.eq("dc_ch",json.getString("dcCh"));
        }
        if(StringUtils.isNotEmpty(json.getString("Zt"))){
            queryWrapper.eq("zt",json.getString("Zt"));
        }
        List<DmXbjh> dmTzjhs=dmXbjhMapper.selectList(queryWrapper);
        return dmTzjhs;
    }

    @Override
    public List<DmXbjh> upload(MultipartFile file) throws IOException {
    //    ExcelReader reader = ExcelUtil.getReader(file.getInputStream());
        List<Map<String,Object>> mapList= ExcelUtil.readDmXbjh(file);

        List<DmXbjh> list=new ArrayList<>();
        mapList.forEach(stringObjectMap -> {
            DmXbjh dmXbjh = modelMapper.map(stringObjectMap, DmXbjh.class);
            list.add(dmXbjh);
        });
        return list;
    }

    @Override
    public void save(List<DmXbjh> dmXbjhs) {
        saveBatch(dmXbjhs);
    }

    @Override
    public void tj(List<DmXbjh> dmXbjhs) {
        dmXbjhs.forEach(dmXbjh -> {
            dmXbjh.setZt("1");
        });
        updateBatchById(dmXbjhs);
    }
}
